<?php

namespace Newpackage\Newpackage\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class FormTransformer extends TransformerAbstract
{
    public function transform(\Newpackage\Newpackage\Models\Form $form)
    {
        return [
            'id'                => $form->getRouteKey(),
            'key'               => [
                'public'    => $form->getPublicKey(),
                'route'     => $form->getRouteKey(),
            ], 
            'name'              => $form->name,
            'url'               => [
                'public'    => trans_url('newpackage/'.$form->getPublicKey()),
                'user'      => guard_url('newpackage/form/'.$form->getRouteKey()),
            ], 
            'status'            => trans('app.'.$form->status),
            'created_at'        => format_date($form->created_at),
            'updated_at'        => format_date($form->updated_at),
        ];
    }
}